SystemOrganization addCategory: #SqueakSVNPlugins!

SmartSyntaxInterpreterPlugin subclass: #SqueakSVNPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 04:13'!
answerSeventeen

	self export: true.
	interpreterProxy
		pop: 1
		thenPush: (interpreterProxy integerObjectOf: 16).! !

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rkrk 1/7/2008 04:15'!
stringTest01

	| oop ptr aString |

	self export: true.
	self var: #aString declareC: 'char *aString'.
	self var: #ptr declareC: 'char *ptr'.
	self cCode: 'aString = "hallo welt"'.
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: 20.
	ptr := interpreterProxy firstIndexableField: oop.
	0 to: 12"size"-1 do:[:i|
		ptr at: i put: (aString at: i)].
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rkrk 1/7/2008 04:13'!
svnAdd

	| targetStringObj target |
	self export: true.
	self var: #stringObj declareC: 'int targetStringObj'. 
	self var: #stringPtr declareC: 'const char *target'.
	targetStringObj := interpreterProxy stackValue: 0. 
	target := self 
		cCoerce: (interpreterProxy arrayValueOf: targetStringObj) 
		to: 'const char *'.
	"Call SVNWrapper function"
	self cCode: 'addTargetToWC (target)'. "Todo: check result (int?) for success or failure"! !

!SqueakSVNPlugin methodsFor: 'svn' stamp: 'rt 1/31/2008 20:27'!
svnCommit

	| targetsObj targets squeakStrings length cString lengthOut |
	self export: true.
	self var: #squeakStrings declareC: 'char** squeakStrings'.
	self var: #targets declareC: 'char** targets'.
	self var: #cString declareC: 'char* cString'.
	self var: #lengthOut declareC: 'int lengthOut'.
	
	targetsObj := interpreterProxy stackValue: 0.
	squeakStrings := interpreterProxy firstIndexableField: targetsObj.
	
	length := interpreterProxy slotSizeOf: targetsObj.
	lengthOut := interpreterProxy integerValueOf: length.
	self cCode: 'targets = (char**) malloc(sizeof(char*)*lengthOut)'.
	
	
	0 to: length - 1 do: [:index |
		cString := self
			cCoerce: (interpreterProxy arrayValueOf: (squeakStrings at: index))
			to: 'char*'.
		targets at: index put: cString].
	
	self cCode: 'commit( lengthOut, targets)'.
	self flag: #TODO."free targets!!!!!!!!!!"! !

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 14:28'!
writeString

	| stringObj stringPtr |
	self export: true.
	self var: #stringObj declareC: 'int stringObj'. 
	self var: #stringPtr declareC: 'char *stringPtr'.
	stringObj := interpreterProxy stackValue: 0. 
	stringPtr := self 
		cCoerce: (interpreterProxy arrayValueOf: stringObj) 
		to: 'char *'.! !
